<script lang="ts">
  import type { IComponent } from './interfaces/IComponent';
  import { ButtonType } from './enums/ButtonType';
  import { Area } from './enums/Area';

  export interface IButtonProps extends IComponent {
    area: Area;
    type?: ButtonType;
    label?: string;
  }

  export let classes: string = undefined,
      area: Area,
      type: ButtonType = undefined,
      label: string = undefined;

  $: classNames.push(
      'duration-100', 'relative', 'bg-neutral-800', 'text-neutral-50', 'font-extrabold', 'text-md', 'px-5', 'py-2.5',
      'hover:rounded-tl-md',
      'before:content-[""]', 'before:duration-100', 'before:absolute', 'before:w-4', 'before:h-4', 'before:-bottom-1.5', 'before:-right-1.5', 'before:z-[-1]',
      'before:hover:rounded-br-md', 'before:hover:rounded-md', 'before:hover:w-full', 'before:hover:h-full',
      'after:content-[""]', 'after:duration-100', 'after:absolute', 'after:w-4', 'after:h-4', 'after:-bottom-1.5', 'after:-right-1.5',
  );
  $: switch (area) {
    case Area.ORG:
      classNames = classes?.split(' ') ?? [];
      classNames.push(
          'after:bg-blue-700',
          'before:hover:bg-blue-700/30'
      );
      break;

    case Area.DEV:
      classNames = classes?.split(' ') ?? [];
      classNames.push(
          'after:bg-red-800',
          'before:hover:bg-red-800/30'
      );
      classNames.push('');
      break;

    case Area.LABS:
      classNames = classes?.split(' ') ?? [];
      classNames.push(
          'after:bg-emerald-500',
          'before:hover:bg-emerald-500/30'
      );
      classNames.push('');
      break;

    case Area.DESIGN:
      classNames = classes?.split(' ') ?? [];
      classNames.push(
          'after:bg-amber-500',
          'before:hover:bg-amber-500/30'
      );
      classNames.push('');
      break;

    case Area.SPACE:
      classNames = classes?.split(' ') ?? [];
      classNames.push(
          'after:bg-violet-700',
          'before:hover:bg-violet-700/30'
      );
      classNames.push('');
      break;
  }
  $: classNames = classNames;
</script>

<button
        {type}
        class={classNames.join(' ')}
        on:click>
    <slot>{label}</slot>
</button>
